REM ======================================================================
REM CFA-10006 BASIC Desmonstration Code
REM Copyright 2008, Crystalfontz America, Inc.
REM http://www.crystalfontz.com
REM 
REM Licensed under the Apache License, Version 2.0 (the "License");
REM you may not use this file except in compliance with the License.
REM You may obtain a copy of the License at
REM 
REM      http://www.apache.org/licenses/LICENSE-2.0
REM 
REM Unless required by applicable law or agreed to in writing, software
REM distributed under the License is distributed on an "AS IS" BASIS,
REM WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
REM implied. See the License for the specific language governing
REM permissions and limitations under the License.
REM ======================================================================
REM Create our variables, full on.
     RED =   100
     GREEN = 100
     BLUE =  100

REM Update the hardware from the variables
     backset 0, RED
     backset 1, GREEN
     backset 2, BLUE

REM The RGB backlight is pretty cool, but it really
REM looks good in dimmer light.
     bitmap "/blsweep/subdued.cf0"
     gosub 2000
     gosub 2000
     gosub 2000
     gosub 2000

REM Put up the background of the backlght sweep screen.
     bitmap "/blsweep/blsweep.cf0"

REM Sweep down to 0,0,0 (the diagonal on the cube).
100  IF (KEYGET()<>0) THEN 9000
     RED = RED - 1
     GREEN = RED
     BLUE = RED
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (0 < RED) THEN 100
     gosub 2000

REM We are going to do a "Hamiltonian path" around
REM the RGB cube:
REM   http://en.wikipedia.org/wiki/Hamiltonian_cycle
REM Basically we treat the RGB channels as a 3-bit
REM Gray code:
REM   http://en.wikipedia.org/wiki/Gray_code
REM and step from 0 to 7.
REM   R G B
REM   0 0 0  Off
REM   0 0 1  blue
REM   0 1 1  turquoise
REM   0 1 0  green
REM   1 1 0  yellow
REM   1 1 1  White
REM   1 0 1  purple
REM   1 0 0  red

REM BLUE from 0 to 100
200 IF (KEYGET()<>0) THEN 9000
     BLUE = BLUE + 1
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (BLUE < 100) THEN 200
     gosub 2000

REM GREEN from 0 to 100
300 IF (KEYGET()<>0) THEN 9000
     GREEN = GREEN + 1
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (GREEN < 100) THEN 300
     gosub 2000

REM BLUE from 100 to 0
400  IF (KEYGET()<>0) THEN 9000
     BLUE = BLUE - 1
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (0 < BLUE) THEN 400
     gosub 2000

REM RED from 0 to 100
500 IF (KEYGET()<>0) THEN 9000
     RED = RED + 1
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (RED < 100) THEN 500
     gosub 2000

REM BLUE from 0 to 100
600 IF (KEYGET()<>0) THEN 9000
     BLUE = BLUE + 1
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (BLUE < 100) THEN 600
     gosub 2000

REM GREEN from 100 to 0
700 IF (KEYGET()<>0) THEN 9000
     GREEN = GREEN - 1
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (0 < GREEN) THEN 700
     gosub 2000

REM BLUE from 100 to 0
800  IF (KEYGET()<>0) THEN 9000
     BLUE = BLUE - 1
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (0 < BLUE) THEN 800
     gosub 2000

REM Now walk the backlight back to 100%
900  IF (KEYGET()<>0) THEN 9000
     GREEN = GREEN + 1
     BLUE = GREEN
     REM Update the PWM and print the values on the LCD.
     GOSUB 3000
     IF (GREEN < 100) THEN 900
     gosub 2000

     RETVAL = 4
     GOTO 9900

2000 REM Interruptible delay subroutine.
     DELCNT = 0
2100 IF (KEYGET()<>0) THEN 9900
     DELCNT = DELCNT + 1
     DELAY 5
     IF (DELCNT < 100) THEN 2100
     RETURN

3000 REM Update the backlight PWM outputs
     backset 0, RED
     backset 1, GREEN
     backset 2, BLUE
     REM print the RGB values at 17,4
     if (9<RED) THEN 3100
     PRINTXY 17, 4, "  "
     PRINTXY 19, 4, str$(RED)
     GOTO 3120
3100 if (99<RED) THEN 3110
     PRINTXY 17, 4, " "
     PRINTXY 18, 4, str$(RED)
     GOTO 3120
3110 PRINTXY 17, 4, str$(RED)
3120 if (9<GREEN) THEN 3200
     PRINTXY 17, 5, "  "
     PRINTXY 19, 5, str$(GREEN)
     GOTO 3220
3200 if (99<GREEN) THEN 3210
     PRINTXY 17, 5, " "
     PRINTXY 18, 5, str$(GREEN)
     GOTO 3220
3210 PRINTXY 17, 5, str$(GREEN)
3220 if (9<BLUE) THEN 3300
     PRINTXY 17, 6, "  "
     PRINTXY 19, 6, str$(BLUE)
     GOTO 3320
3300 if (99<BLUE) THEN 3310
     PRINTXY 17, 6, " "
     PRINTXY 18, 6, str$(BLUE)
     GOTO 3320
3310 PRINTXY 17, 6, str$(BLUE)
3320 RETURN

9000 RETVAL=10
9900 REM "Restore backlight from EEPROM."
     backrest 0
     backrest 1
     backrest 2
     REM Print the values on the LCD.
     RED = backget(0)
     GREEN = backget(1)
     BLUE = backget(2)
     GOSUB 3000
     run "/basic/demo.bas", RETVAL, 0, 0
